#include <iostream>

#include "SourceOperator.hpp"

SourceOperator::SourceOperator()
{
    logger  = log4cxx::Logger::getLogger("source");
}

void SourceOperator::init(int sliceId, int sliceUId, int bucketCount, char* param, int size)
{
    timestampCounterGenerator = 0;
    timestampCounterProcessor = 0;
}

bool SourceOperator::generate(Collector* collector)
{
    void* event = collector->allocEvent(0, timestampCounterGenerator++, sizeof(int));
    *(int*)event = timestampCounterGenerator++;
    collector->commit();
    return true;
}

void SourceOperator::process(int routingKey, void* eventIn, int size, void* state, Collector* collector)
{
    void *eventOut = collector->allocEvent(routingKey, timestampCounterProcessor++, sizeof(int));
    *(int*)eventOut = timestampCounterProcessor;
    LOG4CXX_INFO(logger, "[\033[01;34m" << timestampCounterProcessor << "\033[0m]");
    collector->commit();
}

extern "C"
{
    Operator *operatorInstance()
    {
        return new SourceOperator();
    }
}
