#include <stdio.h>
#include <string.h>
#include <iostream>

#include "WorkerOperator.hpp"

WorkerOperator::WorkerOperator()
{
    logger  = log4cxx::Logger::getLogger("worker");
}

void WorkerOperator::init(int sliceId, int sliceUId, int bucketCount, char* param, int size)
{
    timestampCounterProcessor = 0;
}

void* WorkerOperator::stateInit()
{
    int* counter = new int;
    *counter = 0;
    return counter;
}

int WorkerOperator::getStateSize(void* state)
{
    return sizeof(int);
}

void WorkerOperator::freeState(void* state)
{
    delete (int*)state;
}

void WorkerOperator::stateAccess(int routingKey, void* eventIn, int size, StateAccess* stateAccess)
{
    stateAccess->setKey(0);
}

void WorkerOperator::process(int routingKey, void* eventIn, int size, void* state, Collector* collector)
{
    void *eventOut = collector->allocEvent(routingKey, timestampCounterProcessor++, sizeof(int));
    *(int*)eventOut = timestampCounterProcessor;
    LOG4CXX_INFO(logger, "[\033[01;31m" << timestampCounterProcessor << "\033[0m]");
    collector->commit();
}

extern "C"
{
    Operator *operatorInstance()
    {
        return new WorkerOperator();
    }
}
