#ifndef WORKEROPERATOR_HPP_
#define WORKEROPERATOR_HPP_

#include <log4cxx/logger.h>
#include "OperatorImpl.hpp"

class WorkerOperator : public OperatorImpl
{
private:
    log4cxx::LoggerPtr logger;

    int64_t timestampCounterProcessor;

public:
    WorkerOperator();
    void init(int sliceId, int sliceUId, int bucketCount, char* param, int size);
    void* stateInit();
    int getStateSize(void* state);
    void freeState(void* state);
    void stateAccess(int routingKey, void* eventIn, int size, StateAccess* stateAccess);
    void process(int routingKey, void* eventIn, int size, void* state, Collector* collector);
};

#endif
